/*Реализовать функцию полного клонирования объекта.

Технические требования:

Написать функцию для рекурсивного полного клонирования объекта (без единой передачи по ссылке, внутренняя вложенность свойств объекта может быть достаточно большой).
Функция должна успешно копировать свойства в виде объектов и массивов на любом уровне вложенности.
Использовать синтаксис ES6 для работы с перемеными, функциями и объектами.*/


function makeClone(obj) {
  let clone = {}; // Создаем новый пустой объект
  for (let prop in obj) { // Перебираем все свойства копируемого объекта
    if (obj.hasOwnProperty(prop)) { // Только собственные свойства
      if ("object"===typeof obj[prop]) // Если свойство так же объект
      clone[prop] = makeClone(obj[prop]); // Делаем клон свойства
      else
      clone[prop] = obj[prop]; // Или же просто копируем значение
    }
  }
 return clone;
}